function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".index_highlightSelector__-qiHd {\n  background-color: #fafafa !important;\n  outline: 3px dashed #1976d2 !important;\n  opacity: 0.8 !important;\n  cursor: pointer !important;\n  transition: opacity 0.5s ease !important;\n}\n";
var style = {"highlightSelector":"index_highlightSelector__-qiHd"};
styleInject(css);

var highlight_class = style.highlightSelector;

var Highlighter =
/*#__PURE__*/
function () {
  function Highlighter() {
    var _this = this;

    _classCallCheck(this, Highlighter);

    this.mousemoveEvent = function (event) {
      if (!event.target) {
        return;
      }

      if (!_this.previous) {
        $(event.target).addClass(highlight_class);
      } else {
        $(_this.previous).removeClass(highlight_class);
        $(event.target).addClass(highlight_class);
      }

      _this.previous = event.target;
    };

    this.previous = null;
  }

  _createClass(Highlighter, [{
    key: "start",
    value: function start() {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        $('html').one('click', function (event) {
          if (!_this2.previous) {
            return;
          }

          $(event.target).removeClass(highlight_class);
          $('html').off('mousemove', _this2.mousemoveEvent);
          resolve(event.target);
          _this2.previous = null;
          return false;
        });

        var keydownEventHandler = function keydownEventHandler(event) {
          if (event.keyCode === 27) {
            $('html').find(".".concat(highlight_class)).removeClass(highlight_class);
            $('html').off('mousemove', _this2.mousemoveEvent);
            $('html').off('keydown', keydownEventHandler);
            _this2.previous = null;
            event.preventDefault();
            reject(new Error('Cancel'));
          }
        };

        $('html').on('keydown', keydownEventHandler);
        $('html').on('mousemove', _this2.mousemoveEvent);
      });
    }
  }]);

  return Highlighter;
}();

export default Highlighter;
